/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Application gateway BackendHealthHttp settings.
 *
 */
class ApplicationGatewayBackendHealthHttpSettings {
  /**
   * Create a ApplicationGatewayBackendHealthHttpSettings.
   * @member {object} [backendHttpSettings] Reference of an
   * ApplicationGatewayBackendHttpSettings resource.
   * @member {number} [backendHttpSettings.port] The destination port on the
   * backend.
   * @member {string} [backendHttpSettings.protocol] The protocol used to
   * communicate with the backend. Possible values are 'Http' and 'Https'.
   * Possible values include: 'Http', 'Https'
   * @member {string} [backendHttpSettings.cookieBasedAffinity] Cookie based
   * affinity. Possible values include: 'Enabled', 'Disabled'
   * @member {number} [backendHttpSettings.requestTimeout] Request timeout in
   * seconds. Application Gateway will fail the request if response is not
   * received within RequestTimeout. Acceptable values are from 1 second to
   * 86400 seconds.
   * @member {object} [backendHttpSettings.probe] Probe resource of an
   * application gateway.
   * @member {string} [backendHttpSettings.probe.id] Resource ID.
   * @member {array} [backendHttpSettings.authenticationCertificates] Array of
   * references to application gateway authentication certificates.
   * @member {array} [backendHttpSettings.trustedRootCertificates] Array of
   * references to application gateway trusted root certificates.
   * @member {object} [backendHttpSettings.connectionDraining] Connection
   * draining of the backend http settings resource.
   * @member {boolean} [backendHttpSettings.connectionDraining.enabled] Whether
   * connection draining is enabled or not.
   * @member {number}
   * [backendHttpSettings.connectionDraining.drainTimeoutInSec] The number of
   * seconds connection draining is active. Acceptable values are from 1 second
   * to 3600 seconds.
   * @member {string} [backendHttpSettings.hostName] Host header to be sent to
   * the backend servers.
   * @member {boolean} [backendHttpSettings.pickHostNameFromBackendAddress]
   * Whether to pick host header should be picked from the host name of the
   * backend server. Default value is false.
   * @member {string} [backendHttpSettings.affinityCookieName] Cookie name to
   * use for the affinity cookie.
   * @member {boolean} [backendHttpSettings.probeEnabled] Whether the probe is
   * enabled. Default value is false.
   * @member {string} [backendHttpSettings.path] Path which should be used as a
   * prefix for all HTTP requests. Null means no path will be prefixed. Default
   * value is null.
   * @member {string} [backendHttpSettings.provisioningState] Provisioning
   * state of the backend http settings resource. Possible values are:
   * 'Updating', 'Deleting', and 'Failed'.
   * @member {string} [backendHttpSettings.name] Name of the backend http
   * settings that is unique within an Application Gateway.
   * @member {string} [backendHttpSettings.etag] A unique read-only string that
   * changes whenever the resource is updated.
   * @member {string} [backendHttpSettings.type] Type of the resource.
   * @member {array} [servers] List of ApplicationGatewayBackendHealthServer
   * resources.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationGatewayBackendHealthHttpSettings
   *
   * @returns {object} metadata of ApplicationGatewayBackendHealthHttpSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayBackendHealthHttpSettings',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayBackendHealthHttpSettings',
        modelProperties: {
          backendHttpSettings: {
            required: false,
            serializedName: 'backendHttpSettings',
            type: {
              name: 'Composite',
              className: 'ApplicationGatewayBackendHttpSettings'
            }
          },
          servers: {
            required: false,
            serializedName: 'servers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ApplicationGatewayBackendHealthServerElementType',
                  type: {
                    name: 'Composite',
                    className: 'ApplicationGatewayBackendHealthServer'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayBackendHealthHttpSettings;
