/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the source of connection monitor.
 *
 */
class ConnectionMonitorSource {
  /**
   * Create a ConnectionMonitorSource.
   * @member {string} resourceId The ID of the resource used as the source by
   * connection monitor.
   * @member {number} [port] The source port used by connection monitor.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnectionMonitorSource
   *
   * @returns {object} metadata of ConnectionMonitorSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectionMonitorSource',
      type: {
        name: 'Composite',
        className: 'ConnectionMonitorSource',
        modelProperties: {
          resourceId: {
            required: true,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          port: {
            required: false,
            serializedName: 'port',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectionMonitorSource;
