/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * HTTP configuration of the connectivity check.
 *
 */
class HTTPConfiguration {
  /**
   * Create a HTTPConfiguration.
   * @member {string} [method] HTTP method. Possible values include: 'Get'
   * @member {array} [headers] List of HTTP headers.
   * @member {array} [validStatusCodes] Valid status codes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HTTPConfiguration
   *
   * @returns {object} metadata of HTTPConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HTTPConfiguration',
      type: {
        name: 'Composite',
        className: 'HTTPConfiguration',
        modelProperties: {
          method: {
            required: false,
            serializedName: 'method',
            type: {
              name: 'String'
            }
          },
          headers: {
            required: false,
            serializedName: 'headers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HTTPHeaderElementType',
                  type: {
                    name: 'Composite',
                    className: 'HTTPHeader'
                  }
              }
            }
          },
          validStatusCodes: {
            required: false,
            serializedName: 'validStatusCodes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = HTTPConfiguration;
