/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters that define the configuration of traffic analytics.
 *
 */
class TrafficAnalyticsConfigurationProperties {
  /**
   * Create a TrafficAnalyticsConfigurationProperties.
   * @member {boolean} enabled Flag to enable/disable traffic analytics.
   * @member {string} workspaceId The resource guid of the attached workspace
   * @member {string} workspaceRegion The location of the attached workspace
   * @member {string} workspaceResourceId Resource Id of the attached workspace
   */
  constructor() {
  }

  /**
   * Defines the metadata of TrafficAnalyticsConfigurationProperties
   *
   * @returns {object} metadata of TrafficAnalyticsConfigurationProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TrafficAnalyticsConfigurationProperties',
      type: {
        name: 'Composite',
        className: 'TrafficAnalyticsConfigurationProperties',
        modelProperties: {
          enabled: {
            required: true,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          workspaceId: {
            required: true,
            serializedName: 'workspaceId',
            type: {
              name: 'String'
            }
          },
          workspaceRegion: {
            required: true,
            serializedName: 'workspaceRegion',
            type: {
              name: 'String'
            }
          },
          workspaceResourceId: {
            required: true,
            serializedName: 'workspaceResourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TrafficAnalyticsConfigurationProperties;
